/*
 * Copyright (C) 2023  Valentin Lorentz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License version 3,
 * as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use ratatui::prelude::*;
use ratatui::widgets::Widget;

mod bottom_aligned_paragraph;
pub use bottom_aligned_paragraph::BottomAlignedParagraph;

pub(crate) mod prerender;
pub use prerender::Prerender;

#[rustfmt::skip] // reflow is vendored from ratatui, let's avoid changes
mod reflow;

/// A [`Widget`] that returns how many lines it actually drew to.
pub trait OverlappableWidget {
  fn render_overlap(self, area: Rect, buf: &mut Buffer) -> u16;
}

/*
impl<W: OverlappableWidget> Widget for W {
  fn render(self, area: Rect, buf: &mut Buffer) {
    self.render_overlap(area, buf);
  }
}
*/
